<?php declare(strict_types=1);

namespace Plugin\css_warenkorb\Migrations;

use JTL\Shop;
use JTL\Plugin\Migration;
use JTL\Update\IMigration;

/**
 * Class Migration20210429123301
 * @package Plugin\jtl_test\Migrations
 */
class Migration20210429123301 extends Migration implements IMigration   {
	/**
	 * @inheritdoc
	 */


	public function columnExist($table, $field) {
		// false bedeutet das es die Spalte nicht gibt
		return $this->getDB()->query("Show columns from `" . $table . "` like '" . $field . "' ", 1);
	}

	public function tableExist($table) {
		// in Rows steht die Anzahl der Zeilen, false bedeutet das es die Tabelle nicht gibt
		$obj =  $this->getDB()->query("SHOW TABLE STATUS  like '" . $table . "'", 1);
		if($obj && (int) $obj->Rows == 0) {
			$o = $this->getDB()->query("SELECT COUNT(*) AS anzahl FROM " . $table . " WHERE 1",1);
			$obj->Rows = (int) $o->anzahl;
			return $obj;
		}
		return $obj;
	}







	public function up()    {
		$this->execute("
              CREATE TABLE IF NOT EXISTS `css_warenkorbConfig` (
                  `version` varchar(10) NOT NULL DEFAULT '2.0.0',
                  `sqlupdate` int(10) NOT NULL DEFAULT '0',
                  `pluginActive` varchar(1) NOT NULL DEFAULT 'N',
                  `framework` char(3) NOT NULL default 'B4',
                  `css` text NOT NULL,
                  `js` text NOT NULL,
                  `searchLetters` int(3) NOT NULL DEFAULT '3',
                  `shortLetters` int(3) NOT NULL DEFAULT '10',
                  `basketArticle` char(1) NOT NULL DEFAULT 'D',
                  `searchIn` varchar(1) NOT NULL DEFAULT 'B',
                  `searchLimit` int(11) NOT NULL DEFAULT '20',
                  `searchFor` varchar(1) NOT NULL DEFAULT 'B',
                  `noticeSelector` varchar(255) NOT NULL DEFAULT '#content .basket-heading',
                  `noticePosition` varchar(255) NOT NULL DEFAULT 'after'
                ) ENGINE=InnoDB COLLATE utf8_unicode_ci
        ");

		$this->execute("
              CREATE TABLE IF NOT EXISTS `css_warenkorbData` (
                  `id` int(11) NOT NULL AUTO_INCREMENT,
                  `basketname` varchar(255) NOT NULL DEFAULT '',
                  `url` varchar(255) NOT NULL DEFAULT '',
                  `pluginActive` varchar(1) NOT NULL DEFAULT 'Y',
                  `info` text NOT NULL,
                  `article` text NOT NULL,
                  PRIMARY KEY (`id`)
                ) ENGINE=InnoDB COLLATE utf8_unicode_ci
        ");



		if($this->columnExist('css_warenkorbData','pluginActive')) {
			$this->execute(
				'ALTER TABLE `css_warenkorbData` CHANGE COLUMN  `pluginActive` `urlactive` VARCHAR(1) NOT NULL DEFAULT "Y"'
			);
		}

		if(($obj = $this->tableExist('css_warenkorbConfig')) && $obj->Rows > 0) {
			$this->execute("UPDATE css_warenkorbConfig set `version` = '2.0.0' ");
		} else {
			$this->execute(
				"INSERT INTO `css_warenkorbConfig` (`version`) VALUES ('2.0.0')"
			);
		}

	}

	/**
	 * @inheritdoc
	 */
	public function down() {
		if ($this->doDeleteData()) {
		}
	}
}
