<?php declare(strict_types=1);

namespace Plugin\css_warenkorb\Migrations;

use JTL\Helpers\Text;
use JTL\Plugin\PluginInterface;
use JTL\Shop;
use JTL\Mail\Mail\Mail;
use JTL\Mail\Mailer;


use JTL\Plugin\Migration;
use JTL\Update\IMigration;

/**
 * Class Migration20230130123301
 * @package Plugin\jtl_test\Migrations
 */
class Migration20230130123301 extends Migration implements IMigration   {
	/**
	 * @inheritdoc
	 */

	public function copyTable($sourceDB,$destinationDB="", $copyTable=true,$deleteSourceDB=false) {
		error_log('starte copy '.$sourceDB);
		$result = $this->getDB()->query("SHOW TABLES LIKE '".$sourceDB."'",2);
		if($copyTable && $result !== null && is_array($result) && count($result)) {
			error_log('DB Vorhanden '.$sourceDB);
			$result = $this->getDB()->query("SELECT * FROM ".$sourceDB." WHERE 1",2);
			foreach($result as $oItem) {
				error_log('schreibe Datensatz nach '.$destinationDB);
				$this->getDB()->insert($destinationDB,$oItem);
			}
		}
		if($deleteSourceDB) {
			$this->execute("DROP TABLE IF EXISTS ".$sourceDB,3);
		}
	}




	public function up()    {
		$obj = $this->getDB()->query("Show columns from css_warenkorbConfig like 'pluginActive' ",1 );
		if($obj !== null && isset($obj->Field)) {
			$this->execute("
				ALTER TABLE `css_warenkorbConfig` CHANGE `pluginActive` `pluginActive` VARCHAR(1) NOT NULL DEFAULT 'N';
        ");
		}


		$result = $this->getDB()->query(
			'SELECT * from `css_warenkorbConfig` where 1',
			2
		);

		if($result === null || count($result) < 1) {
			$this->execute(
				"INSERT INTO `css_warenkorbConfig` (`version`) VALUES ('2.1.0')"
			);
		} else {
			$this->execute("UPDATE css_warenkorbConfig set `version` = '2.1.0' ");
		}
	}

	/**
	 * @inheritdoc
	 */
	public function down() {
		if ($this->doDeleteData()) {
		}
	}
}
