<?php declare(strict_types=1);

namespace Plugin\css_warenkorb\Migrations;


use JTL\Plugin\Migration;
use JTL\Update\IMigration;

/**
 * Class Migration20230721123301
 * @package Plugin\jtl_test\Migrations
 */
class Migration20230721123301 extends Migration implements IMigration   {
	/**
	 * @inheritdoc
	 */




	public function columnExist($table, $field) {
		// false bedeutet das es die Spalte nicht gibt
		return $this->getDB()->query("Show columns from `" . $table . "` like '" . $field . "' ", 1);
	}

	public function tableExist($table) {
		// in Rows steht die Anzahl der Zeilen, false bedeutet das es die Tabelle nicht gibt
		$obj =  $this->getDB()->query("SHOW TABLE STATUS  like '" . $table . "'", 1);
		if($obj && (int) $obj->Rows == 0) {
			$o = $this->getDB()->query("SELECT COUNT(*) AS anzahl FROM " . $table . " WHERE 1",1);
			$obj->Rows = (int) $o->anzahl;
			return $obj;
		}
		return $obj;
	}



	public function up()    {

		$this->execute(
			"
								ALTER TABLE `css_warenkorbConfig` CHANGE `framework` `framework` VARCHAR(10)  NOT NULL DEFAULT 'B4';
			");

		if(($obj = $this->tableExist('css_warenkorbConfig')) && $obj->Rows > 0) {
			$this->execute("UPDATE css_warenkorbConfig set `version` = '2.2.0' ");
		} else {
			$this->execute(
				"INSERT INTO `css_warenkorbConfig` (`version`) VALUES ('2.2.0')"
			);
		}


	}

	/**
	 * @inheritdoc
	 */
	public function down() {
		if ($this->doDeleteData()) {
		}
	}
}
