
(function () {
    'use strict';

    var cssFilledBasketClass = function (options) {
        this.init(options);
    };

    cssFilledBasketClass.VERSION = '1.0.0';
    cssFilledBasketClass.DEFAULTS = { 
  			showDebug : false,
  			source: '',
  			minLength: 3,
  			web:'',
  			confirmTemplate: '\
  				<div class="modal fade" id="confirmation_modal" role="dialog" style="display: none;">\
			    	<div class="modal-dialog">\
			    				<div class="modal-content">\
			    			<div class="modal-header">\
			    				<h4 class="modal-title"></h4>\
			    			</div>\
    			<div class="modal-body">\
  				</div>\
			    			<form role="form" method="post" action="category_delete" id="delete_data">\
			    				<div class="modal-footer">\
			    					<button type="button" class="btn btn-danger confirmYes" >Ja ich m&ouml;chte</button>\
			    					<button type="button" class="btn btn-primary" data-dismiss="modal">Nein ich m&ouml;chte nicht</button>\
			    				</div>\
			    			</form>\
			    		</div>\
			    	</div>\
			    </div>\
			',
  			noticeTemplate: '\
  				<div class="modal fade " id="css_modal" role="dialog" style="display: none;">\
			    	<div class="modal-dialog">\
			    				<div class="modal-content">\
			    			<div class="modal-header">\
			    				<h4 class="modal-title"></h4>\
			    			</div>\
    			<div class="modal-body">\
  				</div>\
			    			<!-- <form role="form" method="post" action="" >\
			    				<div class="modal-footer">\
			    					<button type="button" class="btn btn-default" data-dismiss="modal">schlie&szlig;en</button>\
			    				</div>\
			    			</form>-->\
			    		</div>\
			    	</div>\
			    </div>\
			'
    };
    cssFilledBasketClass.prototype = {

        constructor: cssFilledBasketClass,

        init: function (options) {
            this.options = $.extend({}, cssFilledBasketClass.DEFAULTS, options);
            var that = this;
        },

        register: function(options) {
        	var that=this;
        	this.debug("function register started");
        	that.checkTrashButtonStatus();
        	that.initAutoComplete();
        	that.initCopyLink();
        	that.initActiveSelect();
        	that.initBasketChannel();
        	that.initDeleteButton();
					that.codemirror();


					$(".basket-list").on("click",".css-plus", function(e) {
        		e.stopPropagation();
        		var el = $(this).closest(".input-group").clone();

        		$(el).find('.css-autocomplete').removeClass("loaded")	;
        		$(el).find('.css-autocomplete').removeClass("autocompleter-node")	;
        		
        		$(el).find("input").each(function() {
        			if($(this).data("default")) {
          			$(this).val($(this).data("default"));
        			} else {
        				$(this).val("");
        			}
        		});
        		$(".basket-list").append(el);	
          	that.checkTrashButtonStatus();
//          	that.initAutoComplete();
        	})
        	
        	$(".basket-list").on("click",".css-minus", function(e) {
        		e.stopPropagation();
        		var el = $(this).closest(".input-group").remove();
        		that.checkTrashButtonStatus();
        	})
        },

        initDeleteButton: function() {
        	var that = this;
        	$("#content").on("click", "button[name='remove']", function() {
        		that.debug("is clicked");

        		if(!$(this).hasClass("confirmed")) {
      				that.openModalConfirmation(this,"alert alert-danger", "Warning", "Sind Sie sicher das Sie diesen Eintrag l&ouml;schen m&ouml;chten?");
        			return;	
      			} else {
      				$("input[name='cssAdminBasket']").val("deleteBasket");
      				$(this).closest("form").submit();
      				};
        	});
        },

			codemirror: function() {
				$(function() {
					var editorsSmarty = [],
						editorsSass = [],
						editorsHtml = [],
						editorsCSS = [],
						editorsJS = [],
						editorsSQL = [];


					function wc_hex_is_light(color) {
						const hex = color.replace('#', '');
						const c_r = parseInt(hex.substr(0, 2), 16);
						const c_g = parseInt(hex.substr(2, 2), 16);
						const c_b = parseInt(hex.substr(4, 2), 16);
						const brightness = ((c_r * 299) + (c_g * 587) + (c_b * 114)) / 1000;
						return brightness > 155;
					}

					$(document).ready(function () {
						var idListSmarty = $('.css-codemirror.smarty'),
							idListHTML = $('.css-codemirror.html'),
							idListSASS = $('.css-codemirror.sass'),
							idListSQL = $('.css-codemirror.sql'),
							idListCSS = $('.css-codemirror.css'),
							idListJavaScript = $('.css-codemirror.JavaScript'),
							codemirrorTheme = wc_hex_is_light($(':root').css('--body-bg')) ? 'default' : 'ayu-dark';
						idListHTML.each(function (idx, elem) {
							if (elem.id && elem.id.length > 0 && $("#" +elem.id ).hasClass("initialized") == false) {
								editorsHtml[elem.id] = CodeMirror.fromTextArea(document.getElementById(elem.id), {
									lineNumbers:    true,
									mode:           'htmlmixed',
									scrollbarStyle: 'simple',
									lineWrapping:   true,
									readOnly:	($("#"+elem.id).hasClass("readonly")) ? true : false,
									extraKeys:      {
										'Ctrl-Space': function (cm) {
											cm.setOption('fullScreen', !cm.getOption('fullScreen'));
										},
										'Esc':        function (cm) {
											if (cm.getOption('fullScreen')) cm.setOption('fullScreen', false);
										}
									},
									theme: codemirrorTheme
								});
								$("#" +elem.id ).addClass("initialized");
								$("#cssExpertModus").on('shown.bs.collapse', function () {
									editorsHtml[elem.id].refresh();
								});
								$('#myModalInfo').on('shown.bs.modal', function (e) {
									editorsHtml[elem.id].refresh();
								});
								$('.tabs-nav a[data-toggle="tab"]').on('shown.bs.tab', function (e) {
									editorsHtml[elem.id].refresh();
								});
							}
						});
						idListJavaScript.each(function (idx, elem) {
							if (elem.id && elem.id.length > 0 && $("#" +elem.id ).hasClass("initialized") == false) {
								editorsJS[elem.id] = CodeMirror.fromTextArea(document.getElementById(elem.id), {
									lineNumbers:    true,
									mode:           'javascript',
									scrollbarStyle: 'simple',
									lineWrapping:   true,
									readOnly:	($("#"+elem.id).hasClass("readonly")) ? true : false,
									extraKeys:      {
										'Ctrl-Space': function (cm) {
											cm.setOption('fullScreen', !cm.getOption('fullScreen'));
										},
										'Esc':        function (cm) {
											if (cm.getOption('fullScreen')) cm.setOption('fullScreen', false);
										}
									},
									theme: codemirrorTheme
								});
								$("#" +elem.id ).addClass("initialized");
								$("#cssExpertModus").on('shown.bs.collapse', function () {
									editorsJS[elem.id].refresh();
								});
								$('#myModalInfo').on('shown.bs.modal', function (e) {
									editorsJS[elem.id].refresh();
								});
								$('.tabs-nav a[data-toggle="tab"]').on('shown.bs.tab', function (e) {
									editorsJS[elem.id].refresh();
								});
							}
						});
						idListCSS.each(function (idx, elem) {
							if (elem.id && elem.id.length > 0 && $("#" +elem.id ).hasClass("initialized") == false) {
								editorsCSS[elem.id] = CodeMirror.fromTextArea(document.getElementById(elem.id), {
									lineNumbers:    true,
									mode:           'css',
									scrollbarStyle: 'simple',
									lineWrapping:   true,
									readOnly:	($("#"+elem.id).hasClass("readonly")) ? true : false,
									extraKeys:      {
										'Ctrl-Space': function (cm) {
											cm.setOption('fullScreen', !cm.getOption('fullScreen'));
										},
										'Esc':        function (cm) {
											if (cm.getOption('fullScreen')) cm.setOption('fullScreen', false);
										}
									},
									theme: codemirrorTheme
								});
								$("#" +elem.id ).addClass("initialized");
								$("#cssExpertModus").on('shown.bs.collapse', function () {
									editorsCSS[elem.id].refresh();
								});
								$('#myModalInfo').on('shown.bs.modal', function (e) {
									editorsCSS[elem.id].refresh();
								});
								$('.tabs-nav a[data-toggle="tab"]').on('shown.bs.tab', function (e) {
									editorsCSS[elem.id].refresh();
								});
							}
						});
						idListSASS.each(function (idx, elem) {
							if (elem.id && elem.id.length > 0 && $("#" +elem.id ).hasClass("initialized") == false) {
								editorsSass[elem.id] = CodeMirror.fromTextArea(document.getElementById(elem.id), {
									lineNumbers:    true,
									mode:           'sass',
									scrollbarStyle: 'simple',
									lineWrapping:   true,
									readOnly:	($("#"+elem.id).hasClass("readonly")) ? true : false,
									extraKeys:      {
										'Ctrl-Space': function (cm) {
											cm.setOption('fullScreen', !cm.getOption('fullScreen'));
										},
										'Esc':        function (cm) {
											if (cm.getOption('fullScreen')) cm.setOption('fullScreen', false);
										}
									},
									theme: codemirrorTheme
								});
								$("#" +elem.id ).addClass("initialized");
								$("#cssExpertModus").on('shown.bs.collapse', function () {
									editorsSass[elem.id].refresh();
								});
								$('#myModalInfo').on('shown.bs.modal', function (e) {
									editorsSass[elem.id].refresh();
								});
								$('.tabs-nav a[data-toggle="tab"]').on('shown.bs.tab', function (e) {
									editorsSass[elem.id].refresh();
								});
							}
						});
						idListSmarty.each(function (idx, elem) {
							if (elem.id && elem.id.length > 0 && $("#" +elem.id ).hasClass("initialized") == false) {
								editorsSmarty[elem.id] = CodeMirror.fromTextArea(document.getElementById(elem.id), {
									lineNumbers:    true,
									lineWrapping:   true,
									mode:           'smartymixed',
									scrollbarStyle: 'simple',
									readOnly:	($("#"+elem.id).hasClass("readonly")) ? true : false,
									extraKeys:      {
										'Ctrl-Space': function (cm) {
											cm.setOption('fullScreen', !cm.getOption('fullScreen'));
										},
										'Esc':        function (cm) {
											if (cm.getOption('fullScreen')) cm.setOption('fullScreen', false);
										}
									},
									theme: codemirrorTheme
								});
								$("#" +elem.id ).addClass("initialized");
								$("#cssExpertModus").on('shown.bs.collapse', function () {
									editorsSmarty[elem.id].refresh();
								});
								$('#myModalInfo').on('shown.bs.modal', function (e) {
									editorsSmarty[elem.id].refresh();
								});
								$('.tabs-nav a[data-toggle="tab"]').on('shown.bs.tab', function (e) {
									editorsSmarty[elem.id].refresh();
								});
							}
						});
						idListSQL.each(function (idx, elem) {
							if (elem.id && elem.id.length > 0 && $("#" +elem.id ).hasClass("initialized") == false) {
								var hint = $('#' + elem.id).data('hint');
								editorsSQL[elem.id] = CodeMirror.fromTextArea(document.getElementById(elem.id), {
									mode: 'text/x-mysql',
									scrollbarStyle: 'simple',
									lineWrapping:   true,
									smartIndent: true,
									lineNumbers: true,
									matchBrackets : true,
									autofocus: true,
									readOnly:	($("#"+elem.id).hasClass("readonly")) ? true : false,
									extraKeys: {"Ctrl-Space": "autocomplete"},
									hintOptions: hint,
									theme: codemirrorTheme
								});
							}
							$("#" +elem.id ).addClass("initialized");
							$("#cssExpertModus").on('shown.bs.collapse', function () {
								editorsSQL[elem.id].refresh();
							});
							$('#myModalInfo').on('shown.bs.modal', function (e) {
								editorsSQL[elem.id].refresh();
							});
							$('.tabs-nav a[data-toggle="tab"]').on('shown.bs.tab', function (e) {
								editorsSQL[elem.id].refresh();
							});
						});
					});

					// Handler for .ready() called.
				});

			},

			openModalConfirmation: function (el, selector, titel,content) {
    			$("#confirmation_modal").remove();
    			$("body").append(this.options.confirmTemplate);
    			$("#confirmation_modal .modal-content").addClass(selector);
    			$("#confirmation_modal .modal-title").html(titel);
    			$("#confirmation_modal .modal-body").html(content);
    			$("#confirmation_modal .confirmYes").on("click", function() {
    				$(el).addClass("confirmed").trigger("click");
    				$("#confirmation_modal").modal("hide");
    			});
    			$("#confirmation_modal").modal("show");
    		},

        
        initActiveSelect: function() {
          $("#cssActive").on("change", function() {
          	if($(this).val()=='Y') {
          		$(this).removeClass("alert-danger");
          		$(this).addClass("alert-success");
          	} else {

          		$(this).addClass("alert-danger");
          		$(this).removeClass("alert-success");
          	}
          });
        },
        
        initBasketChannel: function() {
        	$("#BasketChannel").on("change",function() {
        		$(this).closest("form").submit();
        	});
        },
        
        initCopyLink: function() {
        	var that = this;
        	
        	$("body").on("click",".copy-angebot", function() {
        		var copyField = $(this).closest(".input-group").find("input[name='url']");
        		var value = $(copyField).val();
        		$(copyField).val(that.options.web +"/" + "angebot_" + value);
        		copyField.select();
        		document.execCommand("copy");
        		$(copyField).val(value).blur();
        	});
        	
        	$("body").on("click",".copy-link", function() {
        		var copyField = $(this).closest(".input-group").find("input[name='url']");
        		var value = $(copyField).val();
        		$(copyField).val(that.options.web +"/" + value);
        		copyField.select();
        		document.execCommand("copy");
        		$(copyField).val(value).blur();
        	});
        },
        
        getSelected: function(el) {
        	console.log(el);
        	var selectedList = $("input.articleId");
        	var list = new Array();
        	if(selectedList.length) {
        		for(var cssCounter = 0; cssCounter<selectedList.length; cssCounter++) {
        			list[cssCounter] = Number($(selectedList[cssCounter]).val());
        		}
        	}
        	return list.join(',');
        },
        
        initAutoComplete: function() {
        	var that = this;
        	that.debug("initialisiere autocomplete");

        	$("body").on("focus",'.css-autocomplete', function() { 
          	$('.css-autocomplete').autocompleter("destroy")	;
        		$('.css-autocomplete').removeClass("autocompleter-node")	;
          	$(".autocompleter").remove();
          	$(this).autocompleter({
	            source: that.options.source,
	            selectFirst:true,
	            forceFixPosition:true,
	            changeWhenSelect:true,
	            focusOpen:true,
	            cache: false,
	            minLength:that.options.minLength,
	            template: '{{ artnr }} - {{ name }}',
	            combine: function(params) {
	            		var isSelected = that.getSelected(this);
	            		var ajaxSearch = true;
	              return {
	                q: params.query,
	                count: params.limit,
	                ajaxSearch: ajaxSearch,
	                isSelected : isSelected
	              };
	            },
	            callback: function(value, index, object) {
	        			    	
	            	$(this).closest(".input-group").find(".articleId").val(object.id);
	            	that.debug(value);
	            	that.debug(object.id);
	            }
        	  });
          });
        },
        
        checkTrashButtonStatus : function() {
      		if($(".basket-list .input-group").length<2) {
      			$(".basket-list .input-group .css-minus").attr("disabled",true);
      		} else {
      			$(".basket-list .input-group .css-minus").attr("disabled",false);
      		}
        },
        
        debug: function(s) {
        	if(this.options.showDebug) {
        		console.log(s);
        	}
        },

    		openModalNotice: function (el, selector, titel,content) {
     			$("#css_modal").remove();
    			$("body").append(this.options.noticeTemplate);
    			if(selector) $("#css_modal .modal-content").addClass(selector);
    			$("#css_modal .modal-title").html(titel);
    			$("#css_modal .modal-body").html(content);
    			$("#css_modal").modal("show");
    		},

    		post_data: function (url, data) {
	      	jQuery.ajax({
					type: 'POST',
					url: url,
					data: data,
					showNoSuggestionNotice: true,
					dataType: 'json',
			    beforeSend: function(jqXHR) {
		        jqXHR.overrideMimeType('text/json;charset=iso-8859-1');
			    },
					success: function(data,responseText,jqXHR) {
						if( jqXHR.status == 204 ) {
							$.cssVouch.debug('sorry, here is nothing to do for me. (Token problem?)')
							return false;
						}
						if( jqXHR.status == 404 ) {
							$.cssVouch.debug('sorry, here is nothing to show you.')
							return false;
						}
						if( jqXHR.status == 403 ) {
							$.cssVouch.debug('sorry, this is no place for you.')
							return false;
						}
						//debug(data);
						if( data.script )	{
							eval(data.script);
						}
            $("body").trigger('contentChanged');
					},
					error: function() {
						this.debug('something is wrong....anything buggy?');
					},
					complete: function() {
							
					}
			});
		},
   };

    $.cssFilledBasket = function(options) {
    	$.cssFB = new cssFilledBasketClass(options);
    	$.cssFB.register();
    	return $.cssFB;
    };
})(jQuery);


