(function () {
	'use strict';

	var cssWarenkorbClass = function (options) {
		this.init(options);
	};

	cssWarenkorbClass.VERSION = '1.0.0';
	cssWarenkorbClass.DEFAULTS = {
		showDebug : false,
		noticeTemplate: '\
  				<div class="modal fade " id="css_warenkorb_modal" role="dialog" style="display: none;">\
			    	<div class="modal-dialog">\
			    				<div class="modal-content">\
			    			<div class="modal-header">\
			    				<h4 class="modal-title"></h4>\
			    			</div>\
    			<div class="modal-body">\
  				</div>\
			    			<!-- <form role="form" method="post" action="" >\
			    				<div class="modal-footer">\
			    					<button type="button" class="btn btn-default" data-dismiss="modal">schlie&szlig;en</button>\
			    				</div>\
			    			</form>-->\
			    		</div>\
			    	</div>\
			    </div>\
			'
	};
	cssWarenkorbClass.prototype = {

		constructor: cssWarenkorbClass,

		init: function (options) {
			this.options = $.extend({}, cssWarenkorbClass.DEFAULTS, options);
			var that = this;
			that.debug("starte cssWarenkorbClass Version: " + cssWarenkorbClass.VERSION);
		},

		register: function(options) {
			var that=this;
			that.initBasketButton();
			$('body').on('shown.bs.modal', function () {
			});
			$("body").on("click",'#css_warenkorb_modal a[aria-label="Close"]', function(e){
				e.preventDefault();
				$('#css_warenkorb_modal').modal("hide");
			});
		},

		debug: function(s) {
			if(this.options.showDebug) {
				console.log(s);
			}
		},


		openModalNotice: function (el, selector, titel,content,KeyClose) {
			if(typeof noKeyClose === "undefined"||keyClose == true ) {
				var keyClose = false;
			}
			if(keyClose === false) {
				var backdrop = 'static';
			} else {
				var backdrop = true;
			}
			var options = {
				show: true,
				keyboard: keyClose,
				backdrop: backdrop
			};

			$("#css_warenkorb_modal").remove();
			$("body").append(this.options.noticeTemplate);
			if(selector) $("#css_warenkorb_modal .modal-content").addClass(selector);
			$("#css_warenkorb_modal .modal-title").html(titel);
			$("#css_warenkorb_modal .modal-body").html(content);
			$("#css_warenkorb_modal").modal(options);
		},


		initBasketButton:	function() {
			var that = this;
			$(document).on('click', '[name="css_warenkorb_addToCart"]', function(el) {
				el.preventDefault();
				el.stopPropagation();
				that.putArtikelInBasket(this);
				return false;
			});
			$(document).on('click', '[name="css_warenkorb_addAllToCart"]', function(el) {
				el.preventDefault();
				el.stopPropagation();
				that.putAllArtikelInBasket(this);
				return false;
			});
		},

		putArtikelInBasket: function(el) {
			var that = this;
			var and = '&';
			var quantityEl = "quantity["+encodeURIComponent($(el).val()) + "]";
			var rs = "io=css_warenkorb_online" + and + "action=putAngebotInBasket";
			rs = rs + and + "jtl_token=" + encodeURIComponent($("[name=\"jtl_token\"]").first().val());
			rs = rs + and + "quantity["+encodeURIComponent($(el).val())+"]" + "=" + $("input[name='" + quantityEl + "']").val();
			this.debug(rs);
			$('[name="css_warenkorb_addToCart"]').attr("disabled",true);
			that.post_data($(".css-angebotsliste").data('shopiourl'),rs);
		},


		putAllArtikelInBasket: function(el) {
			var that = this;
			var and = '&';
			var rs = "io=css_warenkorb_online" + and + "action=putAngebotInBasket";
			rs = rs + and + "jtl_token=" + encodeURIComponent($("[name=\"jtl_token\"]").val());

			$('[name="css_warenkorb_addToCart"]').each(function() {
				var el=this;
				var quantityEl = "quantity["+encodeURIComponent($(el).val()) + "]";
				rs = rs + and + "quantity["+encodeURIComponent($(el).val())+"]" + "=" + $("input[name='" + quantityEl + "']").val();
			});

			this.debug(rs);
			$('[name="css_warenkorb_addToCart"]').attr("disabled",true);
			that.post_data($(".css-angebotsliste").data('shopiourl'),rs);
		},


		openSlick: function() {
			if ($.isFunction($.fn.slick)) {
				$('#css_warenkorb_modal .evo-slider').slick({
					//dots: true,
					arrows: true,
					slidesToShow: 3,
					responsive: [
						{
							breakpoint: 480, // xs
							settings: {
								slidesToShow: 1
							}
						},
						{
							breakpoint: 768, // sm
							settings: {
								slidesToShow: 2
							}
						},
						{
							breakpoint: 992, // md
							settings: {
								slidesToShow: 3
							}
						}
					]
				});
			}
		},


		initWarenkorbPopOver: function(name) {
			var that = this;
			that.debug("initWarenkorbPopOver");
			$("body").on("click", ".popover .close", function(e) {
				that.debug("wurde geklickt");
				e.preventDefault();
				e.stopPropagation();
				$(this).closest(".popover").popover('hide');
			});
			setTimeout(function() {
				$('.' + name + '-list [data-toggle="' + name + '-tooltip"]').popover({
					trigger: 'manual',
					html: true,
					delay: {
						show: 100,
						hide: 800
					},
					animation:true,
					placement: 'top',
					title: function() {
						return $('.' + name + '-' + $(this).data('artikel') + " .css-popover-title").html();
					},
					content: function() {
						return $('.' + name + '-' + $(this).data('artikel') + " .css-popover-content").html();
					}
				})
					.on("mouseenter", function () {
						var _this = this;
						// $(".popover").popover('hide');
						$(this).popover("show");
						$(".popover").on("mouseleave", function () {
							$(_this).popover('hide');
						});
					}).on("mouseleave", function () {
					var _this = this;
					setTimeout(function () {
						if (!$(".popover:hover").length) {
							$(_this).popover("hide");
						}
					}, 300);
				});
			},300);
		},

		post_data: function (url, data) {
			var that=this;
			jQuery.ajax({
				type: 'POST',
				url: url,
				data: data,
				showNoSuggestionNotice: true,
				dataType: 'json',
				beforeSend: function(jqXHR) {
					jqXHR.overrideMimeType('text/json;charset=iso-8859-1');
				},
				success: function(data,responseText,jqXHR) {
					if( jqXHR.status == 204 ) {
						that.debug('sorry, here is nothing to do for me. (Token problem?)')
						return false;
					}
					if( jqXHR.status == 404 ) {
						that.debug('sorry, here is nothing to show you.')
						return false;
					}
					if( jqXHR.status == 403 ) {
						that.debug('sorry, this is no place for you.')
						return false;
					}
					//debug(data);
					if( data.script )	{
						eval(data.script);
					}
					$("body").trigger('contentChanged');
				},
				error: function() {
					that.debug('something is wrong....anything buggy?');
				},
				complete: function() {

				}
			});
		},
	};

	$.cssWarenkorb = function(options) {
		$.cssWk = new cssWarenkorbClass(options);
		$.cssWk.register();
		return $.cssWk;
	};

})(jQuery);

$(document).ready(function () {
	if($('.css_warenkorb').length>0) {
		$.cssWarenkorb();
	}
});



